package druhý;

public class Seznam<T>
{
    public static class Prvek<T>
    {
        private T data;
        private Prvek<T> další;

        public Prvek(T data, Prvek<T> další) {
            this.data = data;
            this.další = další;
        }

        public Prvek(T data) {
            this(data, null);
        }

        public Prvek() {
            this(null, null);
        }

        public T getData() {
            return data;
        }

        public void setData(T data) {
            this.data = data;
        }

        public Prvek<T> getDalší() {
            return další;
        }

        public void setDalší(Prvek<T> další) {
            this.další = další;
        }
        
    }
    
    private Prvek<T> hlava;
    private Prvek<T> zarážka;
    //private T[] pole = new T[10];  // nelze
    
    public Seznam()
    {
        hlava = zarážka = new Prvek<>();
    }
    
    public void vložNaZačátek(T co)
    {
        hlava = new Prvek<>(co, hlava);
    }
    
    @Override
    public String toString()
    {
        StringBuilder výsledek = new StringBuilder("(");
        for(var aktuální = hlava; aktuální != zarážka; aktuální = aktuální.další)
        {
            výsledek.append(aktuální.data);
            if(aktuální.další != zarážka)
            {
                výsledek.append(", ");
            }
        }
        //výsledek.append(')');
        return výsledek.append(')').toString();
    }
    
    public boolean prázdný()
    {
        return hlava == zarážka;
    }
    
    void odstraňPrvní() throws Exception
    {
//        if(!prázdný())
//        {
//            hlava = hlava.další;
//        }
        if(prázdný())
        {
            throw new Exception("Odstraňování z prázdného seznamu");
        }
        hlava = hlava.další;        
    }
    
    public void vyprázdni() 
    {
        try
        {
            while(!prázdný())
            {
                odstraňPrvní();
            }
        }
        catch(Exception e)
        {
            // Úmyslně prázdná obsluha
        }
    }
    
    public Prvek<T> najdi(T co)
    {
        var pom = hlava;
        zarážka.data = co;
        while(!pom.data.equals(co))
        {
            pom = pom.další;
        }
        if(pom == zarážka)
            return null;
        else
            return pom;
    }
    
}
